# Pinpoint Page Builder Validator Module

The Pinpoint Page Builder Validator module is a custom Magento 2 module that extends the default validation capabilities of the Magento 2. It provides additional validation rules for various form fields and user inputs within the Magento 2.

## Features

This module adds the following features and validation rules to Magento 2:

- Number Validation: It checks if a number is within a specified range (min and max). 
- URL Validation: It validates whether a given string is a URL. 
- Anchor Tag Validation: It checks if a string contains anchor tags (a tag elements). 
- Widget Validation: It checks if a string contains widget placeholders ({{widget ...}}). 
- CSS Class Validation: It validates whether a string represents a valid CSS class. 
- Message and URL Validation: It validates that anchor tags and URLs are used exclusively in one field. 
- Nested Widget Validation: It checks that widget placeholders are not nested within certain content types. 
- Object Field Validation: It appears to be a more generic validator for fields that expect an object as input. 
- Calc Value Validation: It checks if a string represents a valid calculation (e.g., calc(50% - 10px)). 
- Grid Size Validation: It validates grid size against certain criteria. 
- Max Grid Size Validation: It validates grid size against a maximum allowed size.

### Known benefits
This module resolves the known Magento 2 bug [Magento 2 default error](https://github.com/magento/magento2-page-builder/issues/797) "Cannot read properties of null (reading 'padding')".

## Installation
```
composer require pinpoint/page-builder-validator 
php bin/magento module:enable Pinpoint_PageBuilderValidator
php bin/magento setup:upgrade
php bin/magento setup:di:compile
```
